Bug 9611 - rpm-devel header files possibly need fixing
rpm-devel header files possibly need fixing
Product: Red Hat Linux
Classification: Retired
Component: rpm (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Jeff Johnson
Depends On:
  Show dependency treegraph
Reported: 2000-02-20 16:16 EST by lars
Modified: 2008-05-01 11:37 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2000-02-21 06:03:35 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description lars 2000-02-20 16:16:09 EST
There is a problem with rpmlib.h, part of the rpm-devel rpm (exists in

rpmlib.h includes several other rpm header files like this:

  #include <rpmio.h>
  #include <dbindex.h>
  #include <header.h>

Unfortunately, a program (such as rpmfind. which is where I ran into this
problem) that includes rpmlib.h like this:

  #include <rpm/rpmlib.h>

Will fail to compile, because the preprocessor will search for
/usr/include/rpmio.h, etc., and will not find them.

The best solution is probably to modify rpmlib.h so that it looks like

  #include <rpm/rpmio.h>
  #include <rpm/dbindex.h>
  #include <rpm/header.h>

So that it no longer depends on client code to pass the
-I/usr/include/rpm flag to the preprocessor.
Comment 1 Jeff Johnson 2000-02-21 06:03:59 EST
Changing to <rpm/rpmio.h> would preven building rpm itself.

A slightly better change is to use "rpmio.h", as that permits
both building rpm and other applications without -I... flags.
However, that breaks certain binding autogenerators (perl? I fergit).

So the supported method of building is to use -I...

Note You need to log in before you can comment on or make changes to this bug.